diff -r 5e0d53cac617 trytond/modules/purchase/purchase.py
--- a/trytond/modules/purchase/purchase.py	Mon Sep 10 15:28:28 2012 +0200
+++ b/trytond/modules/purchase/purchase.py	Mon Sep 24 20:36:42 2012 +0200
@@ -1,7 +1,6 @@
 #This file is part of Tryton.  The COPYRIGHT file at the top level of
 #this repository contains the full copyright notices and license terms.
 import datetime
-import copy
 from decimal import Decimal
 from trytond.model import Workflow, ModelView, ModelSQL, fields
 from trytond.modules.company import CompanyReport
@@ -10,9 +9,18 @@
 from trytond.backend import TableHandler
 from trytond.pyson import Eval, Bool, If, PYSONEncoder, Id
 from trytond.transaction import Transaction
-from trytond.pool import Pool
+from trytond.pool import Pool, PoolMeta
 from trytond.config import CONFIG
 
+__all__ = ['Purchase', 'PurchaseInvoice', 'PurchaseIgnoredInvoice',
+    'PurchaseRecreadtedInvoice', 'PurchaseLine', 'PurchaseLineTax',
+    'PurchaseLineInvoiceLine', 'PurchaseLineIgnoredMove',
+    'PurchaseLineRecreatedMove', 'PurchaseReport', 'Template', 'Product',
+    'ProductSupplier', 'ProductSupplierPrice', 'ShipmentIn', 'Move',
+    'OpenSupplier', 'HandleShipmentExceptionAsk', 'HandleShipmentException',
+    'HandleInvoiceExceptionAsk', 'HandleInvoiceException']
+__metaclass__ = PoolMeta
+
 _STATES = {
     'readonly': Eval('state') != 'draft',
     }
@@ -21,10 +29,8 @@
 
 class Purchase(Workflow, ModelSQL, ModelView):
     'Purchase'
-    _name = 'purchase.purchase'
+    __name__ = 'purchase.purchase'
     _rec_name = 'reference'
-    _description = __doc__
-
     company = fields.Many2One('company.company', 'Company', required=True,
         states={
             'readonly': (Eval('state') != 'draft') | Eval('lines', [0]),
@@ -57,7 +63,7 @@
             required=True, states=_STATES, on_change=['party', 'payment_term'],
             select=True, depends=_DEPENDS)
     party_lang = fields.Function(fields.Char('Party Language',
-        on_change_with=['party']), 'get_function_fields')
+            on_change_with=['party']), 'on_change_with_party_lang')
     invoice_address = fields.Many2One('party.address', 'Invoice Address',
         domain=[('party', '=', Eval('party'))], states=_STATES,
         depends=['state', 'party'])
@@ -71,7 +77,7 @@
             },
         depends=['state'])
     currency_digits = fields.Function(fields.Integer('Currency Digits',
-        on_change_with=['currency']), 'get_function_fields')
+            on_change_with=['currency']), 'on_change_with_currency_digits')
     lines = fields.One2Many('purchase.line', 'purchase', 'Lines',
         states=_STATES, on_change=['lines', 'currency', 'party'],
         depends=_DEPENDS)
@@ -121,15 +127,16 @@
             ('exception', 'Exception'),
             ], 'Shipment State', readonly=True, required=True)
     shipments = fields.Function(fields.One2Many('stock.shipment.in', None,
-        'Shipments'), 'get_function_fields')
+            'Shipments'), 'get_shipments')
     moves = fields.Function(fields.One2Many('stock.move', None, 'Moves'),
-            'get_function_fields')
+        'get_moves')
 
-    def __init__(self):
-        super(Purchase, self).__init__()
-        self._order.insert(0, ('purchase_date', 'DESC'))
-        self._order.insert(1, ('id', 'DESC'))
-        self._error_messages.update({
+    @classmethod
+    def __setup__(cls):
+        super(Purchase, cls).__setup__()
+        cls._order.insert(0, ('purchase_date', 'DESC'))
+        cls._order.insert(1, ('id', 'DESC'))
+        cls._error_messages.update({
                 'invoice_addresse_required': 'Invoice addresses must be '
                 'defined for the quotation.',
                 'warehouse_required': 'A warehouse must be defined for the ' \
@@ -138,8 +145,8 @@
                         'an "Account Payable" on the party "%s"!',
                 'delete_cancel': 'Purchase "%s" must be cancelled before '\
                     'deletion!',
-            })
-        self._transitions |= set((
+                })
+        cls._transitions |= set((
                 ('draft', 'quotation'),
                 ('quotation', 'confirmed'),
                 ('confirmed', 'confirmed'),
@@ -148,7 +155,7 @@
                 ('quotation', 'draft'),
                 ('cancel', 'draft'),
                 ))
-        self._buttons.update({
+        cls._buttons.update({
                 'cancel': {
                     'invisible': ~Eval('state').in_(['draft', 'quotation']),
                     },
@@ -178,9 +185,10 @@
                     },
                 })
         # The states where amounts are cached
-        self._states_cached = ['confirmed', 'done', 'cancel']
+        cls._states_cached = ['confirmed', 'done', 'cancel']
 
-    def init(self, module_name):
+    @classmethod
+    def __register__(cls, module_name):
         cursor = Transaction().cursor
         # Migration from 1.2: packing renamed into shipment
         cursor.execute("UPDATE ir_model_data "\
@@ -193,18 +201,18 @@
                 "WHERE (relation like '%%packing%%' "\
                     "OR name like '%%packing%%') AND module = %s",
                 (module_name,))
-        table = TableHandler(cursor, self, module_name)
+        table = TableHandler(cursor, cls, module_name)
         table.column_rename('packing_state', 'shipment_state')
 
-        super(Purchase, self).init(module_name)
+        super(Purchase, cls).__register__(module_name)
 
         # Migration from 1.2: rename packing to shipment in
         # invoice_method values
-        cursor.execute("UPDATE " + self._table + " "\
+        cursor.execute("UPDATE " + cls._table + " "\
                 "SET invoice_method = 'shipment' "\
                 "WHERE invoice_method = 'packing'")
 
-        table = TableHandler(cursor, self, module_name)
+        table = TableHandler(cursor, cls, module_name)
         # Migration from 2.2: warehouse is no more required
         table.not_null_action('warehouse', 'remove')
 
@@ -212,72 +220,79 @@
         table.not_null_action('purchase_date', 'remove')
 
         # Add index on create_date
-        table = TableHandler(cursor, self, module_name)
+        table = TableHandler(cursor, cls, module_name)
         table.index_action('create_date', action='add')
 
-    def default_payment_term(self):
-        payment_term_obj = Pool().get('account.invoice.payment_term')
-        payment_term_ids = payment_term_obj.search(self.payment_term.domain)
-        if len(payment_term_ids) == 1:
-            return payment_term_ids[0]
+    @classmethod
+    def default_payment_term(cls):
+        PaymentTerm = Pool().get('account.invoice.payment_term')
+        payment_terms = PaymentTerm.search(cls.payment_term.domain)
+        if len(payment_terms) == 1:
+            return payment_terms[0].id
 
-    def default_warehouse(self):
-        location_obj = Pool().get('stock.location')
-        location_ids = location_obj.search(self.warehouse.domain)
-        if len(location_ids) == 1:
-            return location_ids[0]
+    @classmethod
+    def default_warehouse(cls):
+        Location = Pool().get('stock.location')
+        locations = Location.search(cls.warehouse.domain)
+        if len(locations) == 1:
+            return locations[0].id
 
-    def default_company(self):
+    @staticmethod
+    def default_company():
         return Transaction().context.get('company')
 
-    def default_state(self):
+    @staticmethod
+    def default_state():
         return 'draft'
 
-    def default_currency(self):
-        company_obj = Pool().get('company.company')
+    @staticmethod
+    def default_currency():
+        Company = Pool().get('company.company')
         company = Transaction().context.get('company')
         if company:
-            company = company_obj.browse(company)
+            company = Company(company)
             return company.currency.id
 
-    def default_currency_digits(self):
-        company_obj = Pool().get('company.company')
+    @staticmethod
+    def default_currency_digits():
+        Company = Pool().get('company.company')
         company = Transaction().context.get('company')
         if company:
-            company = company_obj.browse(company)
+            company = Company(company)
             return company.currency.digits
         return 2
 
-    def default_invoice_method(self):
-        configuration_obj = Pool().get('purchase.configuration')
-        configuration = configuration_obj.browse(1)
+    @staticmethod
+    def default_invoice_method():
+        Configuration = Pool().get('purchase.configuration')
+        configuration = Configuration(1)
         return configuration.purchase_invoice_method
 
-    def default_invoice_state(self):
+    @staticmethod
+    def default_invoice_state():
         return 'none'
 
-    def default_shipment_state(self):
+    @staticmethod
+    def default_shipment_state():
         return 'none'
 
-    def on_change_party(self, vals):
+    def on_change_party(self):
         pool = Pool()
-        party_obj = pool.get('party.party')
-        address_obj = pool.get('party.address')
-        payment_term_obj = pool.get('account.invoice.payment_term')
-        currency_obj = pool.get('currency.currency')
+        PaymentTerm = pool.get('account.invoice.payment_term')
+        Currency = pool.get('currency.currency')
         cursor = Transaction().cursor
-        res = {
+        changes = {
             'invoice_address': None,
             'payment_term': None,
             'currency': self.default_currency(),
             'currency_digits': self.default_currency_digits(),
-        }
-        if vals.get('party'):
-            party = party_obj.browse(vals['party'])
-            res['invoice_address'] = party_obj.address_get(party.id,
-                    type='invoice')
-            if party.supplier_payment_term:
-                res['payment_term'] = party.supplier_payment_term.id
+            }
+        invoice_address = None
+        payment_term = None
+        if self.party:
+            invoice_address = self.party.address_get(type='invoice')
+            if self.party.supplier_payment_term:
+                payment_term = self.party.supplier_payment_term.id
 
             subquery = cursor.limit_clause('SELECT currency '
                 'FROM "' + self._table + '" '
@@ -285,223 +300,139 @@
                 'ORDER BY id DESC', 10)
             cursor.execute('SELECT currency FROM (' + subquery + ') AS p '
                 'GROUP BY currency '
-                'ORDER BY COUNT(1) DESC', (party.id,))
+                'ORDER BY COUNT(1) DESC', (self.party.id,))
             row = cursor.fetchone()
             if row:
                 currency_id, = row
-                currency = currency_obj.browse(currency_id)
-                res['currency'] = currency.id
-                res['currency_digits'] = currency.digits
+                currency = Currency(currency_id)
+                changes['currency'] = currency.id
+                changes['currency_digits'] = currency.digits
 
-        if res['invoice_address']:
-            res['invoice_address.rec_name'] = address_obj.browse(
-                    res['invoice_address']).rec_name
-        if not res['payment_term']:
-            res['payment_term'] = self.default_payment_term()
-        if res['payment_term']:
-            res['payment_term.rec_name'] = payment_term_obj.browse(
-                    res['payment_term']).rec_name
-        return res
+        if invoice_address:
+            changes['invoice_address'] = invoice_address.id
+            changes['invoice_address.rec_name'] = invoice_address.rec_name
+        else:
+            changes['invoice_address'] = None
+        if payment_term:
+            changes['payment_term'] = payment_term.id
+            changes['payment_term.rec_name'] = payment_term.rec_name
+        else:
+            changes['payment_term'] = self.default_payment_term()
+            if changes['payment_term']:
+                changes['payment_term.rec_name'] = PaymentTerm(
+                    changes['payment_term']).rec_name
+        return changes
 
-    def on_change_with_currency_digits(self, vals):
-        currency_obj = Pool().get('currency.currency')
-        if vals.get('currency'):
-            currency = currency_obj.browse(vals['currency'])
-            return currency.digits
+    def on_change_with_currency_digits(self, name=None):
+        if self.currency:
+            return self.currency.digits
         return 2
 
-    def get_currency_digits(self, purchases):
-        '''
-        Return the number of digits of the currency for each purchases
-
-        :param purchases: a BrowseRecordList of purchases
-        :return: a dictionary with purchase id as key and
-            number of digits as value
-        '''
-        res = {}
-        for purchase in purchases:
-            res[purchase.id] = purchase.currency.digits
-        return res
-
-    def on_change_with_party_lang(self, vals):
-        party_obj = Pool().get('party.party')
-        if vals.get('party'):
-            party = party_obj.browse(vals['party'])
-            if party.lang:
-                return party.lang.code
+    def on_change_with_party_lang(self, name=None):
+        if self.party:
+            if self.party.lang:
+                return self.party.lang.code
         return CONFIG['language']
 
-    def get_tax_context(self, purchase):
-        party_obj = Pool().get('party.party')
-        res = {}
-        if isinstance(purchase, dict):
-            if purchase.get('party'):
-                party = party_obj.browse(purchase['party'])
-                if party.lang:
-                    res['language'] = party.lang.code
-        else:
-            if purchase.party.lang:
-                res['language'] = purchase.party.lang.code
-        return res
+    def get_tax_context(self):
+        context = {}
+        if self.party and self.party.lang:
+            context['language'] = self.party.lang.code
+        return context
 
-    def on_change_lines(self, vals):
+    def on_change_lines(self):
         pool = Pool()
-        currency_obj = pool.get('currency.currency')
-        tax_obj = pool.get('account.tax')
-        invoice_obj = pool.get('account.invoice')
+        Tax = pool.get('account.tax')
+        Invoice = pool.get('account.invoice')
 
-        res = {
+        changes = {
             'untaxed_amount': Decimal('0.0'),
             'tax_amount': Decimal('0.0'),
             'total_amount': Decimal('0.0'),
-        }
-        currency = None
-        if vals.get('currency'):
-            currency = currency_obj.browse(vals['currency'])
-        if vals.get('lines'):
-            context = self.get_tax_context(vals)
+            }
+        if self.lines:
+            context = self.get_tax_context()
             taxes = {}
-            for line in vals['lines']:
-                if line.get('type', 'line') != 'line':
+            for line in self.lines:
+                if getattr(line, 'type', 'line') != 'line':
                     continue
-                res['untaxed_amount'] += line.get('amount') or Decimal(0)
+                changes['untaxed_amount'] += line.amount or Decimal(0)
 
                 with Transaction().set_context(context):
-                    tax_list = tax_obj.compute(line.get('taxes', []),
-                            line.get('unit_price') or Decimal('0.0'),
-                            line.get('quantity') or 0.0)
+                    tax_list = Tax.compute(getattr(line, 'taxes', []),
+                        line.unit_price or Decimal('0.0'),
+                        line.quantity or 0.0)
                 for tax in tax_list:
-                    key, val = invoice_obj._compute_tax(tax, 'in_invoice')
+                    key, val = Invoice._compute_tax(tax, 'in_invoice')
                     if not key in taxes:
                         taxes[key] = val['amount']
                     else:
                         taxes[key] += val['amount']
-            if currency:
+            if self.currency:
                 for value in taxes.itervalues():
-                    res['tax_amount'] += currency_obj.round(currency, value)
-        if currency:
-            res['untaxed_amount'] = currency_obj.round(currency,
-                    res['untaxed_amount'])
-            res['tax_amount'] = currency_obj.round(currency, res['tax_amount'])
-        res['total_amount'] = res['untaxed_amount'] + res['tax_amount']
-        if currency:
-            res['total_amount'] = currency_obj.round(currency,
-                    res['total_amount'])
-        return res
+                    changes['tax_amount'] += self.currency.round(value)
+        if self.currency:
+            changes['untaxed_amount'] = self.currency.round(
+                changes['untaxed_amount'])
+            changes['tax_amount'] = self.currency.round(changes['tax_amount'])
+        changes['total_amount'] = (changes['untaxed_amount']
+            + changes['tax_amount'])
+        if self.currency:
+            changes['total_amount'] = self.currency.round(
+                changes['total_amount'])
+        return changes
 
-    def get_function_fields(self, ids, names):
-        '''
-        Function to compute function fields for purchase ids.
-
-        :param ids: the ids of the purchases
-        :param names: the list of field name to compute
-        :param args: optional argument
-        :return: a dictionary with all field names as key and
-            a dictionary as value with id as key
-        '''
-        res = {}
-        purchases = self.browse(ids)
-        if 'currency_digits' in names:
-            res['currency_digits'] = self.get_currency_digits(purchases)
-        if 'party_lang' in names:
-            res['party_lang'] = self.get_party_lang(purchases)
-        if 'shipments' in names:
-            res['shipments'] = self.get_shipments(purchases)
-        if 'moves' in names:
-            res['moves'] = self.get_moves(purchases)
-        return res
-
-    def get_party_lang(self, purchases):
-        '''
-        Return the language code of the party of each purchases
-
-        :param purchases: a BrowseRecordList of purchases
-        :return: a dictionary with purchase id as key and
-            a language code as value
-        '''
-        res = {}
-        for purchase in purchases:
-            if purchase.party.lang:
-                res[purchase.id] = purchase.party.lang.code
-            else:
-                res[purchase.id] = CONFIG['language']
-        return res
-
-    def get_untaxed_amount(self, ids, name):
+    def get_untaxed_amount(self, name):
         '''
         Return the untaxed amount for each purchases
         '''
-        currency_obj = Pool().get('currency.currency')
-        amounts = {}
-        for purchase in self.browse(ids):
-            if (purchase.state in self._states_cached
-                    and purchase.untaxed_amount_cache is not None):
-                amounts[purchase.id] = purchase.untaxed_amount_cache
+        if (self.state in self._states_cached
+                and self.untaxed_amount_cache is not None):
+            return self.untaxed_amount_cache
+        amount = sum((l.amount for l in self.lines
+                if l.type == 'line'), Decimal(0))
+        return self.currency.round(amount)
+
+    def get_tax_amount(self, name):
+        pool = Pool()
+        Tax = pool.get('account.tax')
+        Invoice = pool.get('account.invoice')
+
+        if (self.state in self._states_cached
+                and self.tax_amount_cache is not None):
+            return self.tax_amount_cache
+        context = self.get_tax_context()
+        taxes = {}
+        for line in self.lines:
+            if line.type != 'line':
                 continue
-            amount = sum((l.amount for l in purchase.lines
-                    if l.type == 'line'), Decimal(0))
-            amounts[purchase.id] = currency_obj.round(purchase.currency,
-                    amount)
-        return amounts
+            with Transaction().set_context(context):
+                tax_list = Tax.compute(line.taxes, line.unit_price,
+                    line.quantity)
+            # Don't round on each line to handle rounding error
+            for tax in tax_list:
+                key, val = Invoice._compute_tax(tax, 'in_invoice')
+                if not key in taxes:
+                    taxes[key] = val['amount']
+                else:
+                    taxes[key] += val['amount']
+        amount = sum((self.currency.round(tax) for tax in taxes.itervalues()),
+            Decimal(0))
+        return self.currency.round(amount)
 
-    def get_tax_amount(self, ids, name):
-        '''
-        Return the tax amount for each purchases
-        '''
-        pool = Pool()
-        currency_obj = pool.get('currency.currency')
-        tax_obj = pool.get('account.tax')
-        invoice_obj = pool.get('account.invoice')
+    def get_total_amount(self, name):
+        if (self.state in self._states_cached
+                and self.total_amount_cache is not None):
+            return self.total_amount_cache
+        return self.currency.round(self.untaxed_amount + self.tax_amount)
 
-        amounts = {}
-        for purchase in self.browse(ids):
-            if (purchase.state in self._states_cached
-                    and purchase.tax_amount_cache is not None):
-                amounts[purchase.id] = purchase.tax_amount_cache
-                continue
-            context = self.get_tax_context(purchase)
-            taxes = {}
-            for line in purchase.lines:
-                if line.type != 'line':
-                    continue
-                with Transaction().set_context(context):
-                    tax_list = tax_obj.compute([t.id for t in line.taxes],
-                            line.unit_price, line.quantity)
-                # Don't round on each line to handle rounding error
-                for tax in tax_list:
-                    key, val = invoice_obj._compute_tax(tax, 'in_invoice')
-                    if not key in taxes:
-                        taxes[key] = val['amount']
-                    else:
-                        taxes[key] += val['amount']
-            amount = sum((currency_obj.round(purchase.currency, tax)
-                    for tax in taxes.itervalues()), Decimal(0))
-            amounts[purchase.id] = currency_obj.round(purchase.currency,
-                amount)
-        return amounts
-
-    def get_total_amount(self, ids, name):
-        '''
-        Return the total amount of each purchases
-        '''
-        currency_obj = Pool().get('currency.currency')
-        amounts = {}
-        for purchase in self.browse(ids):
-            if (purchase.state in self._states_cached
-                    and purchase.total_amount_cache is not None):
-                amounts[purchase.id] = purchase.total_amount_cache
-                continue
-            amounts[purchase.id] = currency_obj.round(purchase.currency,
-                    purchase.untaxed_amount + purchase.tax_amount)
-        return amounts
-
-    def get_invoice_state(self, purchase):
+    def get_invoice_state(self):
         '''
         Return the invoice state for the purchase.
         '''
-        skip_ids = set(x.id for x in purchase.invoices_ignored)
-        skip_ids.update(x.id for x in purchase.invoices_recreated)
-        invoices = [i for i in purchase.invoices if i.id not in skip_ids]
+        skip_ids = set(x.id for x in self.invoices_ignored)
+        skip_ids.update(x.id for x in self.invoices_recreated)
+        invoices = [i for i in self.invoices if i.id not in skip_ids]
         if invoices:
             if any(i.state == 'cancel' for i in invoices):
                 return 'exception'
@@ -511,93 +442,69 @@
                 return 'waiting'
         return 'none'
 
-    def set_invoice_state(self, purchase):
+    def set_invoice_state(self):
         '''
         Set the invoice state.
         '''
-        state = self.get_invoice_state(purchase)
-        if purchase.invoice_state != state:
-            self.write(purchase.id, {
+        state = self.get_invoice_state()
+        if self.invoice_state != state:
+            self.write([self], {
                     'invoice_state': state,
                     })
 
-    def get_shipments(self, purchases):
-        '''
-        Return the shipments for the purchases.
+    def get_shipments(self, name):
+        shipments = []
+        for line in self.lines:
+            for move in line.moves:
+                if move.shipment_in:
+                    if move.shipment_in.id not in shipments:
+                        shipments.append(move.shipment_in.id)
+        return shipments
 
-        :param purchases: a BrowseRecordList of purchases
-        :return: a dictionary with purchase id as key and
-            a list of shipment_in id as value
-        '''
-        res = {}
-        for purchase in purchases:
-            res[purchase.id] = []
-            for line in purchase.lines:
-                for move in line.moves:
-                    if move.shipment_in:
-                        if move.shipment_in.id not in res[purchase.id]:
-                            res[purchase.id].append(move.shipment_in.id)
-        return res
+    def get_moves(self, name):
+        return [m.id for l in self.lines for m in l.moves]
 
-    def get_moves(self, purchases):
-        '''
-        Return the moves for the purchases.
-
-        :param purchases: a BrowseRecordList of purchases
-        :return: a dictionary with purchase id as key and
-            a list of moves id as value
-        '''
-        res = {}
-        for purchase in purchases:
-            res[purchase.id] = []
-            for line in purchase.lines:
-                res[purchase.id].extend([x.id for x in line.moves])
-        return res
-
-    def get_shipment_state(self, purchase):
+    def get_shipment_state(self):
         '''
         Return the shipment state for the purchase.
         '''
-        if purchase.moves:
-            if any(l.move_exception for l in purchase.lines):
+        if self.moves:
+            if any(l.move_exception for l in self.lines):
                 return 'exception'
-            elif all(l.move_done for l in purchase.lines):
+            elif all(l.move_done for l in self.lines):
                 return 'received'
             else:
                 return 'waiting'
         return 'none'
 
-    def set_shipment_state(self, purchase):
+    def set_shipment_state(self):
         '''
         Set the shipment state.
         '''
-        state = self.get_shipment_state(purchase)
-        if purchase.shipment_state != state:
-            self.write(purchase.id, {
+        state = self.get_shipment_state()
+        if self.shipment_state != state:
+            self.write([self], {
                     'shipment_state': state,
                     })
 
-    def get_rec_name(self, ids, name):
-        if not ids:
-            return {}
-        res = {}
-        for purchase in self.browse(ids):
-            res[purchase.id] = purchase.reference or str(purchase.id) \
-                    + ' - ' + purchase.party.name
-        return res
+    def get_rec_name(self, name):
+        return (self.reference or str(self.id)
+            + ' - ' + self.party.name)
 
-    def search_rec_name(self, name, clause):
+    @classmethod
+    def search_rec_name(cls, name, clause):
         names = clause[2].split(' - ', 1)
-        ids = self.search(['OR',
-            ('reference', clause[1], names[0]),
-            ('supplier_reference', clause[1], names[0]),
-            ], order=[])
-        res = [('id', 'in', ids)]
+        purchases = cls.search(['OR',
+                ('reference', clause[1], names[0]),
+                ('supplier_reference', clause[1], names[0]),
+                ], order=[])
+        res = [('id', 'in', [p.id for p in purchases])]
         if len(names) != 1 and names[1]:
             res.append(('party', clause[1], names[1]))
         return res
 
-    def copy(self, ids, default=None):
+    @classmethod
+    def copy(cls, purchases, default=None):
         if default is None:
             default = {}
         default = default.copy()
